from flyteidl.admin import common_pb2 as _common_pb2
from flyteidl.admin import cluster_assignment_pb2 as _cluster_assignment_pb2
from flyteidl.core import execution_pb2 as _execution_pb2
from flyteidl.core import security_pb2 as _security_pb2
from google.protobuf import wrappers_pb2 as _wrappers_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

CLUSTER_ASSIGNMENT: MatchableResource
CLUSTER_RESOURCE: MatchableResource
DESCRIPTOR: _descriptor.FileDescriptor
EXECUTION_CLUSTER_LABEL: MatchableResource
EXECUTION_QUEUE: MatchableResource
PLUGIN_OVERRIDE: MatchableResource
QUALITY_OF_SERVICE_SPECIFICATION: MatchableResource
TASK_RESOURCE: MatchableResource
WORKFLOW_EXECUTION_CONFIG: MatchableResource

class ClusterResourceAttributes(_message.Message):
    __slots__ = ["attributes"]
    class AttributesEntry(_message.Message):
        __slots__ = ["key", "value"]
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    ATTRIBUTES_FIELD_NUMBER: _ClassVar[int]
    attributes: _containers.ScalarMap[str, str]
    def __init__(self, attributes: _Optional[_Mapping[str, str]] = ...) -> None: ...

class ExecutionClusterLabel(_message.Message):
    __slots__ = ["value"]
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class ExecutionQueueAttributes(_message.Message):
    __slots__ = ["tags"]
    TAGS_FIELD_NUMBER: _ClassVar[int]
    tags: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, tags: _Optional[_Iterable[str]] = ...) -> None: ...

class ListMatchableAttributesRequest(_message.Message):
    __slots__ = ["resource_type"]
    RESOURCE_TYPE_FIELD_NUMBER: _ClassVar[int]
    resource_type: MatchableResource
    def __init__(self, resource_type: _Optional[_Union[MatchableResource, str]] = ...) -> None: ...

class ListMatchableAttributesResponse(_message.Message):
    __slots__ = ["configurations"]
    CONFIGURATIONS_FIELD_NUMBER: _ClassVar[int]
    configurations: _containers.RepeatedCompositeFieldContainer[MatchableAttributesConfiguration]
    def __init__(self, configurations: _Optional[_Iterable[_Union[MatchableAttributesConfiguration, _Mapping]]] = ...) -> None: ...

class MatchableAttributesConfiguration(_message.Message):
    __slots__ = ["attributes", "domain", "launch_plan", "project", "workflow"]
    ATTRIBUTES_FIELD_NUMBER: _ClassVar[int]
    DOMAIN_FIELD_NUMBER: _ClassVar[int]
    LAUNCH_PLAN_FIELD_NUMBER: _ClassVar[int]
    PROJECT_FIELD_NUMBER: _ClassVar[int]
    WORKFLOW_FIELD_NUMBER: _ClassVar[int]
    attributes: MatchingAttributes
    domain: str
    launch_plan: str
    project: str
    workflow: str
    def __init__(self, attributes: _Optional[_Union[MatchingAttributes, _Mapping]] = ..., domain: _Optional[str] = ..., project: _Optional[str] = ..., workflow: _Optional[str] = ..., launch_plan: _Optional[str] = ...) -> None: ...

class MatchingAttributes(_message.Message):
    __slots__ = ["cluster_assignment", "cluster_resource_attributes", "execution_cluster_label", "execution_queue_attributes", "plugin_overrides", "quality_of_service", "task_resource_attributes", "workflow_execution_config"]
    CLUSTER_ASSIGNMENT_FIELD_NUMBER: _ClassVar[int]
    CLUSTER_RESOURCE_ATTRIBUTES_FIELD_NUMBER: _ClassVar[int]
    EXECUTION_CLUSTER_LABEL_FIELD_NUMBER: _ClassVar[int]
    EXECUTION_QUEUE_ATTRIBUTES_FIELD_NUMBER: _ClassVar[int]
    PLUGIN_OVERRIDES_FIELD_NUMBER: _ClassVar[int]
    QUALITY_OF_SERVICE_FIELD_NUMBER: _ClassVar[int]
    TASK_RESOURCE_ATTRIBUTES_FIELD_NUMBER: _ClassVar[int]
    WORKFLOW_EXECUTION_CONFIG_FIELD_NUMBER: _ClassVar[int]
    cluster_assignment: _cluster_assignment_pb2.ClusterAssignment
    cluster_resource_attributes: ClusterResourceAttributes
    execution_cluster_label: ExecutionClusterLabel
    execution_queue_attributes: ExecutionQueueAttributes
    plugin_overrides: PluginOverrides
    quality_of_service: _execution_pb2.QualityOfService
    task_resource_attributes: TaskResourceAttributes
    workflow_execution_config: WorkflowExecutionConfig
    def __init__(self, task_resource_attributes: _Optional[_Union[TaskResourceAttributes, _Mapping]] = ..., cluster_resource_attributes: _Optional[_Union[ClusterResourceAttributes, _Mapping]] = ..., execution_queue_attributes: _Optional[_Union[ExecutionQueueAttributes, _Mapping]] = ..., execution_cluster_label: _Optional[_Union[ExecutionClusterLabel, _Mapping]] = ..., quality_of_service: _Optional[_Union[_execution_pb2.QualityOfService, _Mapping]] = ..., plugin_overrides: _Optional[_Union[PluginOverrides, _Mapping]] = ..., workflow_execution_config: _Optional[_Union[WorkflowExecutionConfig, _Mapping]] = ..., cluster_assignment: _Optional[_Union[_cluster_assignment_pb2.ClusterAssignment, _Mapping]] = ...) -> None: ...

class PluginOverride(_message.Message):
    __slots__ = ["missing_plugin_behavior", "plugin_id", "task_type"]
    class MissingPluginBehavior(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = []
    FAIL: PluginOverride.MissingPluginBehavior
    MISSING_PLUGIN_BEHAVIOR_FIELD_NUMBER: _ClassVar[int]
    PLUGIN_ID_FIELD_NUMBER: _ClassVar[int]
    TASK_TYPE_FIELD_NUMBER: _ClassVar[int]
    USE_DEFAULT: PluginOverride.MissingPluginBehavior
    missing_plugin_behavior: PluginOverride.MissingPluginBehavior
    plugin_id: _containers.RepeatedScalarFieldContainer[str]
    task_type: str
    def __init__(self, task_type: _Optional[str] = ..., plugin_id: _Optional[_Iterable[str]] = ..., missing_plugin_behavior: _Optional[_Union[PluginOverride.MissingPluginBehavior, str]] = ...) -> None: ...

class PluginOverrides(_message.Message):
    __slots__ = ["overrides"]
    OVERRIDES_FIELD_NUMBER: _ClassVar[int]
    overrides: _containers.RepeatedCompositeFieldContainer[PluginOverride]
    def __init__(self, overrides: _Optional[_Iterable[_Union[PluginOverride, _Mapping]]] = ...) -> None: ...

class TaskResourceAttributes(_message.Message):
    __slots__ = ["defaults", "limits"]
    DEFAULTS_FIELD_NUMBER: _ClassVar[int]
    LIMITS_FIELD_NUMBER: _ClassVar[int]
    defaults: TaskResourceSpec
    limits: TaskResourceSpec
    def __init__(self, defaults: _Optional[_Union[TaskResourceSpec, _Mapping]] = ..., limits: _Optional[_Union[TaskResourceSpec, _Mapping]] = ...) -> None: ...

class TaskResourceSpec(_message.Message):
    __slots__ = ["cpu", "ephemeral_storage", "gpu", "memory", "storage"]
    CPU_FIELD_NUMBER: _ClassVar[int]
    EPHEMERAL_STORAGE_FIELD_NUMBER: _ClassVar[int]
    GPU_FIELD_NUMBER: _ClassVar[int]
    MEMORY_FIELD_NUMBER: _ClassVar[int]
    STORAGE_FIELD_NUMBER: _ClassVar[int]
    cpu: str
    ephemeral_storage: str
    gpu: str
    memory: str
    storage: str
    def __init__(self, cpu: _Optional[str] = ..., gpu: _Optional[str] = ..., memory: _Optional[str] = ..., storage: _Optional[str] = ..., ephemeral_storage: _Optional[str] = ...) -> None: ...

class WorkflowExecutionConfig(_message.Message):
    __slots__ = ["annotations", "interruptible", "labels", "max_parallelism", "overwrite_cache", "raw_output_data_config", "security_context"]
    ANNOTATIONS_FIELD_NUMBER: _ClassVar[int]
    INTERRUPTIBLE_FIELD_NUMBER: _ClassVar[int]
    LABELS_FIELD_NUMBER: _ClassVar[int]
    MAX_PARALLELISM_FIELD_NUMBER: _ClassVar[int]
    OVERWRITE_CACHE_FIELD_NUMBER: _ClassVar[int]
    RAW_OUTPUT_DATA_CONFIG_FIELD_NUMBER: _ClassVar[int]
    SECURITY_CONTEXT_FIELD_NUMBER: _ClassVar[int]
    annotations: _common_pb2.Annotations
    interruptible: _wrappers_pb2.BoolValue
    labels: _common_pb2.Labels
    max_parallelism: int
    overwrite_cache: bool
    raw_output_data_config: _common_pb2.RawOutputDataConfig
    security_context: _security_pb2.SecurityContext
    def __init__(self, max_parallelism: _Optional[int] = ..., security_context: _Optional[_Union[_security_pb2.SecurityContext, _Mapping]] = ..., raw_output_data_config: _Optional[_Union[_common_pb2.RawOutputDataConfig, _Mapping]] = ..., labels: _Optional[_Union[_common_pb2.Labels, _Mapping]] = ..., annotations: _Optional[_Union[_common_pb2.Annotations, _Mapping]] = ..., interruptible: _Optional[_Union[_wrappers_pb2.BoolValue, _Mapping]] = ..., overwrite_cache: bool = ...) -> None: ...

class MatchableResource(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = []
